/*****************************************************************************************
 *
 *  Copyright 2006+ by Cieszak
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 ****************************************************************************************/

#ifndef MENU_H
#define MENU_H


#include <nokix/all.h>

/**************************************************************************************/

//settings will be saved in config and eeprom
typedef struct settings{         // bitfields replaced with chars, reduces code size
//   unsigned s96:1;             //it is 96x65 screen // replaced with compile-time selection
   unsigned char stats;          //show block statistics
   unsigned char hint;           //show hint where block will be dropped
   unsigned char blockdesign;    //number of design in blockbmp array to draw blocks
   unsigned char total_shapes;   //number of used shapes (7 normal) (10 extra)
   unsigned char level;          //speed level (1-4), can't be a bit-field, because is given to sendmessage address
   unsigned short top_score;

} settings_t;

/* KEEP THIS STRUCTURE <=40 BYTES LONG! */
struct application
{
   unsigned char state;               // current game app state (see below)
   unsigned char old_lights_owner;    // old value of lights_owner, needed for restore

   settings_t settings;               // settings kept here instead of heap, no memory leaking
   
   const struct font *font_plain;    // use rest of the global_buffer[] to store frequently used things
   const struct font *font_bold;
};

/* global_buffer is an array of 40 bytes in RAM which you can use for your
   own purposes as long as your application stays active; when it is deactivated
   the buffer may be overwritten by another one;
   here we define 'app' symbol to access these 40 bytes as a structure */
#define app (*(struct application *)global_buffer)
#define settings (&((struct application *)global_buffer)->settings)	// just make old code compatible

#define STATE_MENU         0
#define STATE_GAME         1
#define STATE_INSTRUCTIONS 2
#define STATE_LEVEL        3
#define STATE_CLEAR_DLG    4
//#define STATE_OPTIONS_MENU 5
//#define STATE_OPTIONS_SUBM 6


/**************************************************************************************/

#endif /* MENU_H */

